// funktion checksum
// berechnet die icmp-kontrollsumme
// funktion pfadfinder 0.3
// sendet ttl-manipulierte icmp-echo-anforderungen
// funktion Horcher
// empfängt die icmpantworten und schreibt ggf. in die Liste
// für fftrace
// gpl
// von hørst

//Bibos
# include "fftrace.h"

int Pfadfinder()
{

//Variablen
 int *icmp_sockel = (int *)&Verwaltung.icmpsock;
 int *id = (int *)&Verwaltung.id;
 unsigned short int *seq = (unsigned short int *)&Verwaltung.seq ;
 struct sockaddr_in Ziel;
 char Zeichen[12];
 struct icmphdr *icmphdr;
 unsigned short int ttl=1;
 fd_set schreibsockel;
 struct timeval zeit;
 int ereignis;
 

 bzero(&Ziel, sizeof(Ziel));
 Ziel.sin_family = AF_INET;
 Ziel.sin_addr.s_addr = Verwaltung.Ziel;
//  printf("pfadfinder2:Ziel: %s \n\n",inet_ntoa(*(struct in_addr *)&Ziel.sin_addr.s_addr));

 bzero(&Zeichen,sizeof(Zeichen));
 icmphdr = (struct icmphdr *)(Zeichen);
 icmphdr->type = 8;
 icmphdr->code = 0;
 icmphdr->un.echo.id = *id & 0xffff;
//  icmphdr->un.echo.sequence = 0;
//  icmphdr->checksum = 0;
 Zeichen[8] =0x4b;
 Zeichen[9] =0x6d;
 Zeichen[10] =0x32;
 Zeichen[11] =0x31;
//  icmphdr->checksum = checksum ((unsigned short *)(icmphdr), (sizeof(Zeichen)) >> 1 );

Verwaltung.flag = 1;
while ( (ttl < MAXHOPS) && (Verwaltung.flag == 1))
{
	

// 	sei das obere byte der icmp-sequenz die nummer unserer durchrufe und das untere die hopnummer
// 	sei auf htons/ntohs verzichtet, da in lokaler endianess geschrieben und gelesen wird

	icmphdr->un.echo.sequence = ((*seq<<8) + ttl) & 0xffff;
	icmphdr->checksum = 0;
	icmphdr->checksum = checksum ((unsigned short *)(icmphdr), (sizeof(Zeichen)) >> 1 );

	if (setsockopt(*icmp_sockel, IPPROTO_IP, IP_TTL, &ttl, sizeof(ttl)) == -1) 
	{	perror ("konnte \"time-to-live\" nicht setzen");
		exit(2);
	}
	
	FD_ZERO(&schreibsockel);
	FD_SET(*icmp_sockel, &schreibsockel);
	ereignis = select(*icmp_sockel+1,NULL,&schreibsockel,NULL,NULL);
	if (ereignis == -1)
	{	perror("select() schimpft:");
	}
	else if(ereignis)
	{	if(sendto(*icmp_sockel,Zeichen,sizeof(Zeichen),0,(struct sockaddr*)&Ziel, sizeof(Ziel))== -1)
		{	perror("senden fehlgeschlagen");
		}
	}
//	kurz warten
	zeit.tv_sec = 0;
	zeit.tv_usec =( 200000+(ttl*5000)); //1000=millisec; 100 000=zentelsekunde
	select(0, NULL, NULL, NULL, &zeit);

	ttl++;
}

*seq=(*seq+1); 
fflush(NULL);

return 0;
}


int Horcher()
{

//Variablen
int *icmp_sockel=(int *)&Verwaltung.icmpsock;
int *id=(int *)&Verwaltung.id;
fd_set lesesockel;
int ereignis;
int n;
char Antwort[60],c;
struct iphdr *iphdr, *oldiphdr;
struct icmphdr *icmphdr, *oldicmphdr;
unsigned short int *hopseq;


do{
	FD_ZERO(&lesesockel);
	FD_SET(*icmp_sockel, &lesesockel);
	if( Verwaltung.param & TERMINALFLAG)
		FD_SET(0,&lesesockel);
	
	ereignis=select(*icmp_sockel+1,&lesesockel,NULL,NULL,NULL);
	if (ereignis == -1)
	{	perror("select() schimpft:");
	}
	else if(ereignis)
	{	
		if(FD_ISSET(0,&lesesockel)) //sthing on stdin
		{
			c=getchar();
			key_stroke_listen(c);
		}
		else
		{
		

		n=recv(*icmp_sockel,Antwort, sizeof(Antwort),0);
		//sollte in einem leserutsch klappen, da wir auf eine ein-paket-datenmenge warten
// 		printf("Horcher: %d\n",n);
		iphdr =   (struct iphdr *)Antwort;

		if(( Pingliste[0].ip) == 0 )
		{	Pingliste[0].ip = iphdr->daddr;}
		

		icmphdr = (struct icmphdr *)(Antwort + sizeof(*iphdr));
		switch (icmphdr->type)
		{
		case 11:	//"ihr Packet ist leider unterwegs gestorben"
			//icmp-h schablone neu (verschoben um ipheader(20) + icmpheader(8) +iphdr alt(20)) drauf
			oldiphdr = (struct iphdr *)(Antwort + sizeof(*iphdr) + sizeof(*icmphdr));
			oldicmphdr = (struct icmphdr *)(Antwort + sizeof(*iphdr) + sizeof(*icmphdr)+ sizeof(*oldiphdr) );
			if(oldicmphdr->un.echo.id == *id)//ist es von unserem ruf(icmp-id)?
			{
				hopseq= (unsigned short int *)(&oldicmphdr->un.echo.sequence );
				Pingliste[ *hopseq & 0xff ].flag = *hopseq >>8;
				Pingliste[ *hopseq & 0xff ].ip = iphdr->saddr;
			}
			break;

		case 3:	//host unreachable
			oldiphdr = (struct iphdr *)(Antwort + sizeof(*iphdr) + sizeof(*icmphdr));
			oldicmphdr = (struct icmphdr *)(Antwort + sizeof(*iphdr) + sizeof(*icmphdr)+ sizeof(*oldiphdr) );
			if(oldicmphdr->un.echo.id == *id)//ist es von unserem ruf(icmp-id)?
			{
				hopseq= (unsigned short int *)(&oldicmphdr->un.echo.sequence );
				Pingliste[ (*hopseq & 0xff) ].ip = iphdr->saddr;
				Pingliste[ (*hopseq & 0xff) ].flag = (*hopseq >>8)+512;
				if (*hopseq >>8 == Verwaltung.seq)
				{	Verwaltung.flag=0;}
			}
			break;
		case 0:		//"bin gut angekommen!"
			if(icmphdr->un.echo.id == *id)//ist es von unserem ruf(icmp-id)?
			{
				hopseq= (unsigned short int *)(&icmphdr->un.echo.sequence );
				Pingliste[ (*hopseq & 0xff) ].ip = iphdr->saddr;
				Pingliste[ (*hopseq & 0xff) ].flag = (*hopseq >>8)+256;
				if (*hopseq >>8 == Verwaltung.seq)
				{	
					Verwaltung.flag=0;
// 					returned_pings++;
				}
			}
			break;
		default:
			break;
		}
		}
	fflush(NULL);
	}
}while(1);
return 0;
}

